<?
IPSLogger_SetOutEcho(false, c_LogLevel_All);

IPSUtils_Include ("IPSLight.inc.php",					"IPSLibrary::app::modules::IPSLight");

class Eltako_FSR14
{
	// Diese Funktion wertet die Informationen fr den FSB14 aus und akutalisiert die Variablen
	function ENO_FSR14_get($ReceiveArray)
	{
		//Daten extrahieren
		$RSSI = $ReceiveArray[0];
		$UserData = $ReceiveArray[1];
		$InstanceID = $ReceiveArray[2];
		$DeviceName = $ReceiveArray[3];

		$LightDevice = IPSLight_GetLightConfiguration();
		$lightManager = new IPSLight_Manager();
	
		//RSSI schreiben
		//$RSSIvalue = IPS_GetVariableIDByName("RSSI", $InstanceID); //VariablenID von RSSI;
		//SetValue($RSSIvalue,$RSSI);

		//UserData verarbeiten
		$LUserData = count($UserData);
		IPSLogger_Dbg(__function__, "LUserData: ".$LUserData."\n");
		switch ($LUserData)
		{
			case 1: //FSR14-2x, FSR14-4x, FSR14SSR, FFR14, FMS14, FMZ14, FTN14, FZK14
				$MyStatus = $UserData[0];
				IPSLogger_Dbg(__function__, "Status: ".$MyStatus."\n");
				switch ($MyStatus)
				{
					// 0x70 "Ein";
					case "70":
						$deviceState = 1;
					break;

					// 0x50 "Aus";
					case "50":
						$deviceState = 0;
					break;
				} // End switch($MovementCode)
				$lightManager->SynchronizeSwitch($DeviceName, $deviceState);
				IPSLogger_Dbg(__function__, "Der Status wurde fr Switch $DeviceName synchronisiert.\n");
			break;

			case 4: //FUD14, FUD14-800W, FSG14/1-10V - $BS-Telegram
				// $UserData[0] Immer "02"
				$Dimmwert 	= hexdec($UserData[1]); // Dimmwert in %
				// $UserData[2] Immer "00"
				$MyStatus 		= $UserData[3]; // "08" = aus  "09" = an
				
				// Status bestimmen
				switch ($MyStatus)
				{
					case "08": //aus
						$deviceState = 0;
						IPSLogger_Dbg(__function__, "Dimmer ist aus, bei $Dimmwert %\n");
					break;

					case "09": //an
						$deviceState = 1;
						IPSLogger_Dbg(__function__, "Dimmer ist an, bei $Dimmwert %\n");
					break;
				} // End switch ($MyStatus)
				
				$lightManager->SynchronizeDimmer($DeviceName, $deviceState, $Dimmwert);
				IPSLogger_Dbg(__function__, "Der Status wurde fr Dimmer $DeviceName synchronisiert.\n");
			break;
		} // Ende switch ($LUserData)
	} // Ende ENO_FSR14_get()

	function ENO_FSR14_send()
	{
	} // Ende ENO_FSR14_send()
}

?>
