 <?
IPSUtils_Include ("IPSLogger.inc.php", "IPSLibrary::app::core::IPSLogger");
IPSLogger_SetOutEcho(false, c_LogLevel_All);
 
include_once("ENO_Code_Handler.ips.php");

$mydebug = false;
$myoutput = false;


if($_IPS['SENDER']  == "RegisterVariable")
{
	// berprfen ob das erste Bit 0x55 ist
   $str = Str2Hex($_IPS['VALUE']);
   $strarray = str_split($str,2);

	// echo $strarray[0];
   if ($strarray[0] == "55")
   {
		$data = $str;
		IPSLogger_Dbg(__file__, "Start String: ".$data."\n");
	} else {
		$data  = RegVar_GetBuffer($_IPS['INSTANCE']); // liest das bestehende array aus
		$data = $data.$str;
    	IPSLogger_Dbg(__file__, "kombinierter String: ".$data."\n");
	};
	RegVar_SetBuffer($_IPS['INSTANCE'], $data); // speichert den String zwischen
	

// Den String wieder in ein Array mit den Hex werten zerlegen
	$DataArray = str_split($data,2); // String in Array Zerlegen
   $strlen = count($DataArray); // zhlt die Lnge des Arrays
   
// berprfen ob zumindest der Header vollstndig ist. Mindestens 6 Bit)
	if ($strlen >= 6)
	{
		// Daten aus Header Auslesen fr ESP3
		$LData = hexdec($DataArray[2]);
		$LOData = hexdec($DataArray[3]);
		$PType = hexdec($DataArray[4]);
		IPSLogger_Dbg(__file__, "Lnge Data: ".$LData."\n");
		IPSLogger_Dbg(__file__, "Lnge OptData: ".$LOData."\n");
		IPSLogger_Dbg(__file__, "Packet Type: ".$PType."\n");
		
      $SollPakete = 6 + $LData + $LOData + 1;// Soll Gre der Pakete (Header(6) + Data * OData + CRC8D)
      IPSLogger_Dbg(__file__, "Soll Lnge: ".$SollPakete."\n");
		IPSLogger_Dbg(__file__, "Arraygre: ".$strlen."\n");
		// Bisher keine CRC8 berprfung
		
		// berprfung der vollstndigen bertragung
		if ($SollPakete <= $strlen) // bei schnellem schalten sind die pakete teilweise grer?
		{
         echo "Vollstndige bertragung";
			IPSLogger_Dbg(__file__, "Vollstndige bertragung\n");

			// MyData String erzeugen
			$MyData = array_slice($DataArray, 6, $LData);
			IPSLogger_Dbg(__file__, "Data: ".implode(" ",$MyData)."\n");

			// MyOData String erzeugen
			$MyOData = array_slice($DataArray, 6+$LData, $LOData);
			IPSLogger_Dbg(__file__, "Optional Data: ".implode(" ",$MyOData)."\n");
	
			// Code bergeben
			$ENO_Code = new ENO_Code_Handler($LData,$LOData,$PType,$MyData,$MyOData);
			$ENO_Code->ENO_Code_Identification();
			$ENO_Code->ENO_Device_Identification();
	 	} else
		{
			echo "Unvollstndige bertragung";
			IPSLogger_Dbg(__file__, "Unvollstndige bertragung");
	 	};
	} else
	{
		echo "Unvollstndige bertragung";
	};
};


function Str2Hex($daten)
{
    $Hex = "";
     for($i=0; $i<strlen($daten); $i++)
   $Hex .= sprintf("%02X", ord($daten[$i]));
     return $Hex;
}

?>
